signature MATHLIB =
sig
val fact : int -> int
val half_pi : real
val doubler : int -> int
val two : int
end

structure MyMathLib :> MATHLIB =
struct

fun fact n =
  if n = 0
  then 1
  else n * fact (n - 1)
val half_pi = Math.pi / 2.0
fun doubler x = x * 2
val two = doubler 1
end
